//+-----------------------------------------------------------------------------------------------+
//|                                                                                 ExcelTest.mq4 |
//|                                                                                   Zloy Koldun |
//+-----------------------------------------------------------------------------------------------+
#property copyright "Zloy Koldun"
#property version   "1.00"
#property strict

#include <ComObject.mqh>

string fileName = "Test2";

static string mySymbol = Symbol();
static ComObject* Connection = NULL;
static int counter = 0;
//+-----------------------------------------------------------------------------------------------+
//| Expert initialization function                                                                |
//+-----------------------------------------------------------------------------------------------+
int OnInit()
{
#ifdef _WIN64
   if( !_IsX64 ){
      Alert( "The program only works in a 64-bit terminal!" );
      return INIT_FAILED;
   }
#else
   if( _IsX64 ){
      Alert( "The program only works in a 32-bit terminal!" );
      return INIT_FAILED;
   }
#endif

   HRESULT result = CoInitialize( 0 );
   if( result != S_OK ){
      return INIT_FAILED;
   }
   
   Connection = new ComObject( "ADODB.Connection" );
   if( !Connection.isValid() ){
      return INIT_FAILED;
   }

   string terminal_data_path = TerminalInfoString( TERMINAL_DATA_PATH ) + "\\MQL4\\Files\\";
   string ConnectionString = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" + terminal_data_path + fileName + ";Extended Properties=\"Excel 12.0 Xml;HDR=Yes\";";
   Variant varResult = Connection.Function( "Open", Variant( ConnectionString ) );
   if( !varResult.isValid() ){
      PrintError( Connection );
      return INIT_FAILED;
   }
   
   varResult = Connection.Function( "Execute", Variant( "drop table " + mySymbol ) );
   if( !varResult.isValid() ){
      PrintError( Connection );
   }
   
   string sql = "create table " + mySymbol + "( [Time] DATETIME, [Ask] double, [Bid] double, [Last] double, [Time_msc] long, [Flags] long )";
   varResult = Connection.Function( "Execute", Variant( sql ) );
   if( !varResult.isValid() ){
      PrintError( Connection );
      return INIT_FAILED;
   }
   
   return INIT_SUCCEEDED;
}
//+-----------------------------------------------------------------------------------------------+
//| Expert deinitialization function                                                              |
//+-----------------------------------------------------------------------------------------------+
void OnDeinit( const int reason )
{
   if( CheckPointer( Connection ) == POINTER_DYNAMIC ){
      if( Connection.isValid() ){
         Connection.Function( "Close" );
      }
      delete Connection;
   }
   CoUninitialize();
}
//+-----------------------------------------------------------------------------------------------+
//| Expert tick function                                                                          |
//+-----------------------------------------------------------------------------------------------+
void OnTick()
{
   MqlTick tick;
   if( SymbolInfoTick( mySymbol, tick ) ){
      string strExecute = "insert into " + mySymbol + "( [Time], [Ask], [Bid], [Last], [Time_msc], [Flags] ) values( '";
      strExecute += TimeToString( tick.time, TIME_DATE|TIME_MINUTES|TIME_SECONDS );
      strExecute += "', ";
      strExecute += DoubleToString( tick.ask, 5 );
      strExecute += ", ";
      strExecute += DoubleToString( tick.bid, 5 );
      strExecute += ", ";
      strExecute += DoubleToString( tick.last, 5 );
      strExecute += ", ";
      strExecute += IntegerToString( (uint)tick.time_msc );
      strExecute += ", ";
      strExecute += IntegerToString( tick.flags );
      strExecute += " )";
      Variant varResult = Connection.Function( "Execute", Variant( strExecute ) );
      if( !varResult.isValid() ){
         PrintError( Connection );
      }
   }
   if( ++counter > 65000 ){
      ExpertRemove();
   }
}
//+-----------------------------------------------------------------------------------------------+
void PrintError( const ComObject& object )
{
   ComObject Errors = object.GetProperty( "Errors" );
   Variant varErrs = Errors.GetProperty( "Count" );
   int Errs = varErrs.toInt();
   if( Errs ){
      ComObject error = Errors.GetProperty( "Item", Variant(0) );
      Variant varDescription = error.GetProperty( "Description" );
      string strDescription = varDescription.toString();
      Print( strDescription );
   }
   else {
      Print( "Unknown error!" );
   }
}
//+-----------------------------------------------------------------------------------------------+
